#include "macros.h" // needs to be declared as first entry in .cpp or .h file!
#include <iostream>
#include <string>
#include <typeinfo>
using namespace std;
#include "AbstractExercise.h"
#include "ExerciseStore.h"

/**
 * The Abstract Exercise.
 * Superclass of all Exercises
 *
 * &copy; Bernhard Wagner, xmlizer.biz, 2002.
 */
AbstractExercise::AbstractExercise(){
	init(typeid(this).name());
}

AbstractExercise::AbstractExercise(string name){
	init(name);
}

void AbstractExercise::getInput(){
}

void AbstractExercise::start(){
	cout << "Exercise <" << getName() << "> started" << endl;
	getInput();
	execute();
}

void AbstractExercise::init(string name){
	fName = name;
	ExerciseStore::instance()->putExercise(this);
//	cout << "created Exercise <" << getName() << ">" <<endl;
}

AbstractExercise::~AbstractExercise(){
//	cout << "destroyed Exercise <" << getName() << ">" << endl;
}

void AbstractExercise::execute(){
	cout << "AbstractExercise::execute " << endl;
}
