#include "macros.h" // needs to be declared as first entry in .cpp or .h file!
#include <iostream>
#include <string>
#include "Driver.h"
#include "AbstractExercise.h"
#include "ExerciseStore.h"
using namespace std;

/**
 * The Driver
 *
 * &copy; Bernhard Wagner, xmlizer.biz, 2002.
 */
int Driver::instantiate(string name){
	AbstractExercise *ae = ExerciseStore::instance()->getExercise(name);
	if(ae == 0){
		cout << "Exercise <" << name << "> not found." << endl;
	} else {
		cout << endl;
		ae->start();
		cout << endl;
		waitForKey();
	}
	return 0;
}

Driver::~Driver(){
	ExerciseStore::destroyInstance();
}

void Driver::waitForKey(){
	string str;
	cout << "Press ENTER key:" << endl;
	cin.ignore(INT_MAX, '\n');
	cin.get();
}
