#include "macros.h" // needs to be declared as first entry in .cpp or .h file!
#include <string>
#include <iostream>
using namespace std;
#include "AbstractExercise.h"

/**
 * The Exercise2.
 *
 * &copy; Bernhard Wagner, xmlizer.biz, 2002.
 */
class Exercise2 : public AbstractExercise {
public:

	/**
	 * Constructor.
	 *
	 * @param name The name of the Exercise
	 */
	Exercise2(string name) : AbstractExercise(name){}

protected:

	/**
	 * Gets the input for this exercise.
	 * To be overridden in subclasses. (Hook Method)
	 */
	void execute();
};
	
/**
 * Instantiates an object of type Exercise2 and stores it in the ExerciseStore.
 * unnamed namespace: file scope (not visible outside this file -> no naming conflicts!)
 * See Bjarne Stroustrup "The C++ Programming Language" Special Edition, Addison-Wesley 2000, p. 200
 */
namespace {
	Exercise2 proto("Exercise2");
}

void Exercise2::execute(){
	cout << "yep Exercise <"<< getName() <<"> here" << endl;
	cout << (-1)%4<<endl;
}
