#include "macros.h" // needs to be declared as first entry in .cpp or .h file!
#include <iostream>
#include <string>
#include "ExerciseStore.h"
#include "AbstractExercise.h"
using namespace std;
/**
 * The ExerciseStore.
 *
 * &copy; Bernhard Wagner, xmlizer.biz, 2002.
 */

AbstractExercise *ExerciseStore::getExercise(string key){
	return fExerciseMap[key];
}

int ExerciseStore::putExercise(string key, AbstractExercise *exercise){
//	cout << "stored: <"<< exercise->getName() << "> under key <" << key << ">" << endl;
	fExerciseMap[key] = exercise;
	return 0;
}

int ExerciseStore::putExercise(AbstractExercise *exercise){
	putExercise(exercise->getName(), exercise);
	return 0;
}

ExerciseStore *ExerciseStore::instance(){
	if(fInstance == 0){
		fInstance = new ExerciseStore();
	}
	return fInstance;
}

void ExerciseStore::destroyInstance(){
	delete fInstance;
}

ExerciseStore *ExerciseStore::fInstance;
